#include "thinkeramik.h"
#include <qlayout.h>
#include <kapp.h>
#include <ksimpleconfig.h>
#include <klocale.h>
#include <qvbuttongroup.h>
#include <qvgroupbox.h>
#include <qlayout.h>
#include <qhbox.h>
#include <qradiobutton.h>
#include <qcheckbox.h>
#include <qtabwidget.h>
#include <qslider.h>
#include <qlabel.h>
#include <kcolorbutton.h>
#include <qsettings.h>
#include <kipc.h>
#include <qfiledialog.h>
#include <qdir.h>
#include <qfile.h>

void ThinKeramikConfig::save()
{
    saveSettings("/qt");
    KIPC::sendMessageAll(KIPC::StyleChanged, 0);
    emit changed(false);
}

void ThinKeramikConfig::saveSettings(const QString &searchPath)
{
    QSettings *settings = new QSettings;
    QString aValue;

    if(useCustomColorBtn1->isOn()){
        settings->writeEntry(searchPath + "/ThinKmk/MenuFG",  "#" + aValue.sprintf("%06x",
                             (menuFgBtn->color().red()*65536 + menuFgBtn->color().green()*256 + menuFgBtn->color().blue())) );
        settings->writeEntry(searchPath + "/ThinKmk/MenuBG",  "#" + aValue.sprintf("%06x",
                             (menuBgBtn->color().red()*65536 + menuBgBtn->color().green()*256 + menuBgBtn->color().blue())) );
        settings->writeEntry(searchPath + "/ThinKmk/MenuStripe", "#" +  aValue.sprintf("%06x",
			     (menuStripeBtn->color().red()*65536 + menuStripeBtn->color().green()*256 + menuStripeBtn->color().blue())) );
    } else {
        settings->removeEntry(searchPath + "/ThinKmk/MenuFG");
        settings->removeEntry(searchPath + "/ThinKmk/MenuBG");
        settings->removeEntry(searchPath + "/ThinKmk/MenuStripe");
    }

    settings->writeEntry(searchPath + "/ThinKmk/EnableGradation", enableGradBtn->isOn());
    if (enableGradBtn->isOn()) {
        settings->writeEntry(searchPath + "/ThinKmk/CustomGradation", customGradBtn->isOn());
    } else {
        settings->removeEntry(searchPath + "/ThinKmk/CustomGradation");
    }

    if (useMenuBGI->isOn()) {
        settings->writeEntry(searchPath + "/ThinKmk/MenuBGImage", menubgfile->text());
        settings->writeEntry(searchPath + "/ThinKmk/ScaledMenuBGImage", scaledMenuBGI->isOn());
    } else {
        settings->removeEntry(searchPath + "/ThinKmk/MenuBGImage");
        settings->removeEntry(searchPath + "/ThinKmk/ScaledMenuBGImage");
    }

    if(useCustomColorBtn1b->isOn()){
        settings->writeEntry(searchPath + "/ThinKmk/MenuBorder", "#" + aValue.sprintf("%06x",
			     (borderColBtn->color().red()*65536 + borderColBtn->color().green()*256 + borderColBtn->color().blue())) );
    } else {
        settings->removeEntry(searchPath + "/ThinKmk/MenuBorder");
    }


    if(useCustomColorBtn1c->isOn()){
        settings->writeEntry(searchPath + "/ThinKmk/MenuSelectedFG",  "#" + aValue.sprintf("%06x",
                             (menuSelFgBtn->color().red()*65536 + menuSelFgBtn->color().green()*256 + menuSelFgBtn->color().blue())) );
        settings->writeEntry(searchPath + "/ThinKmk/MenuSelectedBG",  "#" + aValue.sprintf("%06x",
                             (menuSelBgBtn->color().red()*65536 + menuSelBgBtn->color().green()*256 + menuSelBgBtn->color().blue())) );
        settings->writeEntry(searchPath + "/ThinKmk/MenuSelectedShadow", "#" +  aValue.sprintf("%06x",
			     (menuSelShdBtn->color().red()*65536 + menuSelShdBtn->color().green()*256 + menuSelShdBtn->color().blue())) );
    } else {
        settings->removeEntry(searchPath + "/ThinKmk/MenuSelectedFG");
        settings->removeEntry(searchPath + "/ThinKmk/MenuSelectedBG");
        settings->removeEntry(searchPath + "/ThinKmk/MenuSelectedShadow");
    }

    settings->writeEntry(searchPath + "/ThinKmk/Strong3DMI", strong3dmi->isOn());
    settings->writeEntry(searchPath + "/ThinKmk/Strong3DMS", strong3dms->isOn());
    settings->writeEntry(searchPath + "/ThinKmk/EnableMenuItem3D", enableMI3d->isOn());
    settings->writeEntry(searchPath + "/ThinKmk/EnableStripe3D", enableMS3d->isOn());

    if(useCustomColorBtn2->isOn()){
        settings->writeEntry(searchPath + "/ThinKmk/ActiveTab", "#" + aValue.sprintf("%06x",
			     (activeTabBtn->color().red()*65536 + activeTabBtn->color().green()*256 + activeTabBtn->color().blue())) );
    } else {
        settings->removeEntry(searchPath + "/ThinKmk/ActiveTab");
    }

    settings->writeEntry(searchPath + "/ThinKmk/DisableUpperLines", disableUpperLinesBtn->isOn());

    if(useCustomColorBtn3->isOn()){
        settings->writeEntry(searchPath + "/ThinKmk/Scrollbar", "#" + aValue.sprintf("%06x",
			     (scrollbarBtn->color().red()*65536 + scrollbarBtn->color().green()*256 + scrollbarBtn->color().blue())) );
        settings->writeEntry(searchPath + "/ThinKmk/ScrollArrowbtn", "#" + aValue.sprintf("%06x",
			     (scrollArbBtn->color().red()*65536 + scrollArbBtn->color().green()*256 + scrollArbBtn->color().blue())) );
    } else {
        settings->removeEntry(searchPath + "/ThinKmk/Scrollbar");
        settings->removeEntry(searchPath + "/ThinKmk/ScrollArrowbtn");
    }

    if(useCustomColorBtn4->isOn()){
        settings->writeEntry(searchPath + "/ThinKmk/ButtonPrelight", "#" + aValue.sprintf("%06x",
			     (btnprlBtn->color().red()*65536 + btnprlBtn->color().green()*256 + btnprlBtn->color().blue())) );
    } else {
        settings->removeEntry(searchPath + "/ThinKmk/ButtonPrelight");
    }

    settings->writeEntry(searchPath + "/ThinKmk/UseShadowTextMenu", useShdM->isOn());
    settings->writeEntry(searchPath + "/ThinKmk/DisableShadowEmphasis", disableShdEmpBtn->isOn());
    settings->writeEntry(searchPath + "/ThinKmk/UseShadowTextMenuBar", useShdMB->isOn());
    settings->writeEntry(searchPath + "/ThinKmk/UseShadowTextButton", useShdB->isOn());
    settings->writeEntry(searchPath + "/ThinKmk/UseShadowTextTab", useShdT->isOn());

    settings->writeEntry(searchPath + "/ThinKmk/UseSeamlessKickerMode", useSlk->isOn());

    settings->writeEntry(searchPath + "/ThinKmk/UseFlatBevel", useFlb->isOn());

    settings->writeEntry(searchPath + "/ThinKmk/UsePushbuttonForDefault", usePBforDB->isOn());

    settings->writeEntry(searchPath + "/ThinKmk/DisableBarBorder", disableBB->isOn());

    delete settings; // force sync

}

void ThinKeramikConfig::load()
{
  loadSettings("/qt");
    emit changed(false);
}

void ThinKeramikConfig::loadSettings(const QString &searchPath)
{
    QSettings settings;

    QString mfgcolstr = settings.readEntry(searchPath + "/ThinKmk/MenuFG");
    QString mbgcolstr = settings.readEntry(searchPath + "/ThinKmk/MenuBG");
    QString mstcolstr = settings.readEntry(searchPath + "/ThinKmk/MenuStripe");

    if (!mbgcolstr.isNull()) {
          useCustomColorBtn1->setChecked(true);
          menuFgBtn->setColor(QColor(mfgcolstr));
	  menuBgBtn->setColor(QColor(mbgcolstr));
	  menuStripeBtn->setColor(QColor(mstcolstr));
    } else {
          useCustomColorBtn1->setChecked(false);
	  menuFgBtn->setColor(colorGroup().text());
	  menuBgBtn->setColor(colorGroup().background().light(110));
	  menuStripeBtn->setColor(colorGroup().mid());
    }

    enableGradBtn->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/EnableGradation"));
    customGradBtn->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/CustomGradation"));

    QString mbgifile = settings.readEntry(searchPath + "/ThinKmk/MenuBGImage");
    if (!mbgifile.isNull()) {
          useMenuBGI->setChecked(true);
          menubgfile->setText(mbgifile);
    } else {
          useMenuBGI->setChecked(false);
          menubgfile->setText("");
    }
    scaledMenuBGI->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/ScaledMenuBGImage"));

    QString bordercolstr = settings.readEntry(searchPath + "/ThinKmk/MenuBorder");

    if (!bordercolstr.isNull()) {
          useCustomColorBtn1b->setChecked(true);
	  borderColBtn->setColor(QColor(bordercolstr));
    } else {
          useCustomColorBtn1b->setChecked(false);
	  borderColBtn->setColor(colorGroup().shadow());
    }

    QString mselfgcolstr = settings.readEntry(searchPath + "/ThinKmk/MenuSelectedFG");
    QString mselbgcolstr = settings.readEntry(searchPath + "/ThinKmk/MenuSelectedBG");
    QString mselshdcolstr = settings.readEntry(searchPath + "/ThinKmk/MenuSelectedShadow");

    if (!mselbgcolstr.isNull()) {
          useCustomColorBtn1c->setChecked(true);
          menuSelFgBtn->setColor(QColor(mselfgcolstr));
	  menuSelBgBtn->setColor(QColor(mselbgcolstr));
	  menuSelShdBtn->setColor(QColor(mselshdcolstr));
    } else {
          useCustomColorBtn1c->setChecked(false);
	  menuSelFgBtn->setColor(colorGroup().highlightedText());
	  menuSelBgBtn->setColor(colorGroup().highlight());
	  menuSelShdBtn->setColor(colorGroup().highlight().dark(130));
    }

    strong3dmi->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/Strong3DMI"));
    strong3dms->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/Strong3DMS"));
    enableMI3d->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/EnableMenuItem3D"));
    enableMS3d->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/EnableStripe3D"));

    QString atcolstr = settings.readEntry(searchPath + "/ThinKmk/ActiveTab");

    if (!atcolstr.isNull()) {
          useCustomColorBtn2->setChecked(true);
	  activeTabBtn->setColor(QColor(atcolstr));
    } else {
          useCustomColorBtn2->setChecked(false);
	  activeTabBtn->setColor(colorGroup().highlight());
    }

    disableUpperLinesBtn->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/DisableUpperLines"));

    QString sbcolstr = settings.readEntry(searchPath + "/ThinKmk/Scrollbar");
    QString sacolstr = settings.readEntry(searchPath + "/ThinKmk/ScrollArrowbtn");
    if (sacolstr.isNull() && !sbcolstr.isNull()) {
          sacolstr = sbcolstr;
    }

    if (!sbcolstr.isNull()) {
          useCustomColorBtn3->setChecked(true);
	  scrollbarBtn->setColor(QColor(sbcolstr));
	  scrollArbBtn->setColor(QColor(sacolstr));
    } else {
          useCustomColorBtn3->setChecked(false);
	  scrollbarBtn->setColor(QColor(settings.readEntry(searchPath + "/KWinPalette/inactiveBackground", "#d8d8d8")));
	  scrollArbBtn->setColor(QColor(settings.readEntry(searchPath + "/KWinPalette/inactiveBackground", "#d8d8d8")));
    }

    QString btnprlcolstr = settings.readEntry(searchPath + "/ThinKmk/ButtonPrelight");
    if (!btnprlcolstr.isNull()) {
          useCustomColorBtn4->setChecked(true);
	  btnprlBtn->setColor(QColor(btnprlcolstr));
    } else {
          useCustomColorBtn4->setChecked(false);
	  btnprlBtn->setColor(colorGroup().button().light(105));
    }

    useShdM->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/UseShadowTextMenu"));
    disableShdEmpBtn->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/DisableShadowEmphasis"));
    useShdMB->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/UseShadowTextMenuBar"));
    useShdB->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/UseShadowTextButton"));
    useShdT->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/UseShadowTextTab"));

    useSlk->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/UseSeamlessKickerMode"));

    useFlb->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/UseFlatBevel"));

    usePBforDB->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/UsePushbuttonForDefault"));

    disableBB->setChecked(settings.readBoolEntry(searchPath + "/ThinKmk/DisableBarBorder"));

    slotUseCustomColor1Clicked(useCustomColorBtn1->isChecked());
    slotUseCustomColor1bClicked(useCustomColorBtn1b->isChecked());
    slotUseCustomColor1cClicked(useCustomColorBtn1c->isChecked());
    slotUseMenuBGIClicked(useMenuBGI->isChecked());
    slotEnable3DMIBtnClicked(enableMI3d->isChecked());
    slotEnable3DMSBtnClicked(enableMS3d->isChecked());
    slotEnableGradClicked(enableGradBtn->isChecked());
    slotUseCustomColor2Clicked(useCustomColorBtn2->isChecked());
    slotDisableUpperLinesClicked(disableUpperLinesBtn->isChecked());
    slotUseCustomColor3Clicked(useCustomColorBtn3->isChecked());
    slotUseCustomColor4Clicked(useCustomColorBtn4->isChecked());
    slotUseShadowMClicked(useShdM->isChecked());
    slotBtnColorChanged(colorGroup().background());

}

void ThinKeramikConfig::defaults()
{
    load();
    emit changed(true);
}

void ThinKeramikConfig::slotBtnColorChanged(const QColor &)
{
    emit changed(true);
}

void ThinKeramikConfig::slotCheckBtnClicked(bool en)
{
    emit changed(true);
}

void ThinKeramikConfig::slotTextChanged(const QString &)
{
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor1Clicked(bool en)
{
    menuFgBtn->setEnabled(en);
    menuBgBtn->setEnabled(en);
    menuStripeBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor1bClicked(bool en)
{
    borderColBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor1cClicked(bool en)
{
    menuSelFgBtn->setEnabled(en);
    menuSelBgBtn->setEnabled(en);
    menuSelShdBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseMenuBGIClicked(bool en)
{
    menubgfile->setEnabled(en);
    menubgBrowse->setEnabled(en);
    scaledMenuBGI->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotMenuBGIBrowser()
{
    QString findStartDir = menubgfile->text();
    if (findStartDir.isNull()) {
          findStartDir = QDir::homeDirPath();
    } else if (findStartDir.length() == 0) {
          findStartDir = QDir::homeDirPath();
    }

    QString mbgifile = QFileDialog::getOpenFileName(
                             findStartDir,
			     "Images (*.png *.xpm *.jpg *.bmp *.PNG *.XPM *.JPG *.BMP)",
			     this,
			     "open file dialog"
			     "Select menu background" );

    if (!mbgifile.isNull()) {
          menubgfile->setText(mbgifile);
    }
    emit changed(true);
}

void ThinKeramikConfig::slotEnable3DMIBtnClicked(bool en)
{
    strong3dmi->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotEnable3DMSBtnClicked(bool en)
{
    strong3dms->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotEnableGradClicked(bool en)
{
    customGradBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor2Clicked(bool en)
{
    activeTabBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotDisableUpperLinesClicked(bool en)
{
    useCustomColorBtn2->setEnabled(!en);
    activeTabBtn->setEnabled(useCustomColorBtn2->isOn() && !disableUpperLinesBtn->isOn());
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor3Clicked(bool en)
{
    scrollbarBtn->setEnabled(en);
    scrollArbBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseCustomColor4Clicked(bool en)
{
    btnprlBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotUseShadowMClicked(bool en)
{
    disableShdEmpBtn->setEnabled(en);
    emit changed(true);
}

void ThinKeramikConfig::slotLoadScheme()
{
    loadSettings("/thinkeramik_" + schemeName->text() + ".kcm");
    emit changed(true);
}

void ThinKeramikConfig::slotSaveScheme()
{
    saveSettings("/thinkeramik_" + schemeName->text() + ".kcm");
    searchScheme();
}

void ThinKeramikConfig::slotDelScheme()
{
    QFile delFile1(QDir::homeDirPath() + "/.qt/thinkeramik_" + schemeName->text() + ".kcmrc");

    if (delFile1.exists()) {
          delFile1.remove();
          searchScheme();
    }

    QFile delFile2(QDir::homeDirPath() + "/.qt/.thinkeramik_" + schemeName->text() + ".kcmrc.lock");

    if (delFile2.exists()) {
          delFile2.remove();
    }
}

void ThinKeramikConfig::slotSchemeListClicked(QListBoxItem *item)
{
      if (item) {
            schemeName->setText(item->text());
      }
}

void ThinKeramikConfig::searchScheme()
{
    schemeListBox->clear();

    QDir schemeDir(QDir::homeDirPath() + "/.qt", "thinkeramik_*.kcmrc");
    uint schemeCount = schemeDir.count();
    for (uint sidx = 0; sidx<schemeCount; sidx++) {
          QString schemeFile = schemeDir[sidx];
	  uint fnameLen = schemeFile.length();
	  if (fnameLen > 19) {
	        schemeFile = schemeFile.right(fnameLen - 12);
		schemeFile = schemeFile.left(fnameLen - 12 - 6);
		schemeListBox->insertItem(schemeFile);
	  }
    }

}

ThinKeramikConfig::ThinKeramikConfig(QWidget *parent, const char *name)
    : KCModule(parent, name)
{
    QVBoxLayout *layout = new QVBoxLayout(this);
    QTabWidget *tabWidget = new QTabWidget(this);
    layout->addWidget(tabWidget);

    //--- tab 1 ---

    QWidget *page1 = new QWidget(tabWidget);
    tabWidget->insertTab(page1, i18n("Menu Options 1"));

    layout = new QVBoxLayout(page1);
    layout->addSpacing(5);

    // Menu colors
    QVGroupBox *colorGrp1 = new QVGroupBox(i18n("Menu colors"), page1);
    QWidget *colorFrame1  = new QWidget(colorGrp1);
    QGridLayout *cLayout1 = new QGridLayout(colorFrame1, 1, 1, 2);

    useCustomColorBtn1 = new QCheckBox(i18n("Use custom colors"), colorFrame1);
    cLayout1->addMultiCellWidget(useCustomColorBtn1, 1, 1, 0, 3);

    cLayout1->addWidget(new QLabel(i18n("Widget:"), colorFrame1), 2, 0);
    cLayout1->addWidget(new QLabel(i18n("Color:"), colorFrame1), 2, 1);

    cLayout1->addWidget(new QLabel(i18n("Foreground:"), colorFrame1), 3, 0);
    cLayout1->addWidget(new QLabel(i18n("Background:"), colorFrame1), 4, 0);
    cLayout1->addWidget(new QLabel(i18n("Stripe:"), colorFrame1), 5, 0);

    menuFgBtn = new KColorButton(colorFrame1);
    cLayout1->addWidget(menuFgBtn, 3, 1);
    menuBgBtn = new KColorButton(colorFrame1);
    cLayout1->addWidget(menuBgBtn, 4, 1);
    menuStripeBtn = new KColorButton(colorFrame1);
    cLayout1->addWidget(menuStripeBtn, 5, 1);

    cLayout1->addMultiCellWidget(new QLabel(i18n("Custom menu colors are effective in"), colorFrame1), 6, 6, 0, 3);
    cLayout1->addMultiCellWidget(new QLabel(i18n("XRender-Blend mode or Disable-Translucent mode."), colorFrame1), 7, 7, 1, 3);

    enableGradBtn = new QCheckBox(i18n("Enable gradation in the XRender-Blend mode"), colorFrame1);
    cLayout1->addMultiCellWidget(enableGradBtn, 8, 8, 0, 3);

    customGradBtn = new QCheckBox(i18n("Custom gradation (Background color to Stripe color)"), colorFrame1);
    cLayout1->addMultiCellWidget(customGradBtn, 9, 9, 1, 3);

    connect(useCustomColorBtn1, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor1Clicked(bool)));
    connect(menuFgBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(menuBgBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(menuStripeBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(enableGradBtn, SIGNAL(toggled(bool)), this,
            SLOT(slotEnableGradClicked(bool)));
    connect(customGradBtn, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));

    cLayout1->setColStretch(3, 1);
    layout->addWidget(colorGrp1);
    layout->addSpacing(5);

    // Menu Border
    QVGroupBox *colorGrp1b = new QVGroupBox(i18n("Menu Border"), page1);
    useCustomColorBtn1b = new QCheckBox(i18n("Draw menu border"), colorGrp1b);
    connect(useCustomColorBtn1b, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor1bClicked(bool)));
    QHBox *colorBox1b = new QHBox(colorGrp1b);
    QLabel *borderColBtnLbl = new QLabel(i18n("Border color:"), colorBox1b);
    borderColBtn = new KColorButton(colorBox1b);
    connect(borderColBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    colorBox1b->setStretchFactor(new QWidget(colorBox1b), 1);
    layout->addWidget(colorGrp1b);

    layout->addSpacing(5);

    // Selected Menu Item colors
    QVGroupBox *colorGrp1c = new QVGroupBox(i18n("Selected Menu Item"), page1);
    QWidget *colorFrame1c  = new QWidget(colorGrp1c);
    QGridLayout *cLayout1c = new QGridLayout(colorFrame1c, 1, 1, 2);

    useCustomColorBtn1c = new QCheckBox(i18n("Use custom colors"), colorFrame1c);
    cLayout1c->addMultiCellWidget(useCustomColorBtn1c, 1, 1, 0, 2);

    cLayout1c->addWidget(new QLabel(i18n("Widget:"), colorFrame1c), 2, 0);
    cLayout1c->addWidget(new QLabel(i18n("Color:"), colorFrame1c), 2, 1);

    cLayout1c->addWidget(new QLabel(i18n("Foreground:"), colorFrame1c), 3, 0);
    cLayout1c->addWidget(new QLabel(i18n("Background:"), colorFrame1c), 4, 0);
    cLayout1c->addWidget(new QLabel(i18n("Shadow:"), colorFrame1c), 5, 0);

    menuSelFgBtn = new KColorButton(colorFrame1c);
    cLayout1c->addWidget(menuSelFgBtn, 3, 1);
    menuSelBgBtn = new KColorButton(colorFrame1c);
    cLayout1c->addWidget(menuSelBgBtn, 4, 1);
    menuSelShdBtn = new KColorButton(colorFrame1c);
    cLayout1c->addWidget(menuSelShdBtn, 5, 1);

    connect(useCustomColorBtn1c, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor1cClicked(bool)));
    connect(menuSelFgBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(menuSelBgBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(menuSelShdBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));


    cLayout1c->setColStretch(2, 1);
    layout->addWidget(colorGrp1c);

    layout->addStretch(1);

    //--- tab 1-2 ---

    QWidget *page1p2 = new QWidget(tabWidget);
    layout = new QVBoxLayout(page1p2);
    layout->addSpacing(5);
    tabWidget->insertTab(page1p2, i18n("Menu Options 2"));

    // Menu BG Image
    QVGroupBox *bgiGrp = new QVGroupBox(i18n("Menu Background Image"), page1p2);
    useMenuBGI = new QCheckBox(i18n("Draw menu background image (XRender-Blend mode only)"), bgiGrp);
    connect(useMenuBGI, SIGNAL(toggled(bool)), this,
            SLOT(slotUseMenuBGIClicked(bool)));

    QHBox *bgiBox = new QHBox(bgiGrp);
    QLabel *menubgfileLbl = new QLabel(i18n("Image File:"), bgiBox);
    menubgfile = new QLineEdit(bgiBox);
    menubgfile->setMinimumSize(300,8);
    menubgBrowse = new QPushButton(i18n("Browse..."),bgiBox);

    QHBox *bgiBox2 = new QHBox(bgiGrp);
    QLabel *menubgfileLbldmy1 = new QLabel(i18n("     "), bgiBox2);
    scaledMenuBGI = new QCheckBox(i18n("Use scaled image (Default is tiled)"), bgiBox2);

    connect(menubgfile, SIGNAL(textChanged(const QString &)), this,
            SLOT(slotTextChanged(const QString &)));
    connect(menubgBrowse, SIGNAL(clicked()), this,
            SLOT(slotMenuBGIBrowser()));
    connect(scaledMenuBGI, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));

    QLabel *useMenuBGILbl1 = new QLabel(i18n("If a menu background image is used, neither custom settings of"), bgiGrp);
    QLabel *useMenuBGILbl2 = new QLabel(i18n("the menu background and the menu stripe nor use of gradation are effective."), bgiGrp);

    bgiBox->setStretchFactor(new QWidget(bgiBox), 1);
    bgiBox2->setStretchFactor(new QWidget(bgiBox2), 1);
    layout->addWidget(bgiGrp);
    layout->addSpacing(5);

    // Menu 3D Effect
    QVGroupBox *effectGrp3d = new QVGroupBox(i18n("3D Effect of Menu"), page1p2);

    QLabel *enableMenu3dLbl = new QLabel(i18n("Check widgets which enable 3D effect."), effectGrp3d);
    QLabel *enableMenu3dLbldmy1 = new QLabel("", effectGrp3d);
    enableMI3d = new QCheckBox(i18n("Selected menu item"), effectGrp3d);
    strong3dmi = new QCheckBox(i18n("Strong 3D effect for selected menu item"), effectGrp3d);
    QLabel *enableMenu3dLbldmy2 = new QLabel("", effectGrp3d);
    enableMS3d = new QCheckBox(i18n("Menu stripe"), effectGrp3d);
    strong3dms = new QCheckBox(i18n("Strong 3D effect for menu stripe"), effectGrp3d);
    QLabel *enableMenu3dLbldmy3 = new QLabel("", effectGrp3d);
    QLabel *enableMenu3dLbl2 = new QLabel(i18n("In custom gradation mode or using menu background image,"), effectGrp3d);
    QLabel *enableMenu3dLbl3 = new QLabel(i18n("menu stripe 3D effect is invalid."), effectGrp3d);

    connect(enableMI3d, SIGNAL(toggled(bool)), this,
            SLOT(slotEnable3DMIBtnClicked(bool)));
    connect(strong3dmi, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(enableMS3d, SIGNAL(toggled(bool)), this,
            SLOT(slotEnable3DMSBtnClicked(bool)));
    connect(strong3dms, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));

    layout->addWidget(effectGrp3d);

    layout->addStretch(1);

    //--- tab 2 ---

    QWidget *page2 = new QWidget(tabWidget);
    layout = new QVBoxLayout(page2);
    layout->addSpacing(5);

    tabWidget->insertTab(page2, i18n("Custom Colors"));

    // Upper lines of Active Tab
    QVGroupBox *colorGrp2 = new QVGroupBox(i18n("Upper lines of Active Tab"), page2);
    useCustomColorBtn2 = new QCheckBox(i18n("Use custom color"), colorGrp2);
    connect(useCustomColorBtn2, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor2Clicked(bool)));
    QHBox *colorBox2 = new QHBox(colorGrp2);
    QLabel *activeTabLbl = new QLabel(i18n("Custom color:"), colorBox2);
    activeTabBtn = new KColorButton(colorBox2);
    connect(activeTabBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    colorBox2->setStretchFactor(new QWidget(colorBox2), 1);
    disableUpperLinesBtn = new QCheckBox(i18n("Disable upper lines"), colorGrp2);
    connect(disableUpperLinesBtn, SIGNAL(toggled(bool)), this,
            SLOT(slotDisableUpperLinesClicked(bool)));
    layout->addWidget(colorGrp2);
    layout->addSpacing(5);

    // Scrollbar colors
    QVGroupBox *colorGrp3 = new QVGroupBox(i18n("Scrollbar colors"), page2);
    QWidget *colorFrame3  = new QWidget(colorGrp3);
    QGridLayout *cLayout3 = new QGridLayout(colorFrame3, 1, 1, 5);

    useCustomColorBtn3 = new QCheckBox(i18n("Use custom colors"), colorFrame3);
    cLayout3->addMultiCellWidget(useCustomColorBtn3, 1, 1, 0, 3);

    cLayout3->addWidget(new QLabel(i18n("Widget:"), colorFrame3), 2, 0);
    cLayout3->addWidget(new QLabel(i18n("Color:"), colorFrame3), 2, 1);

    cLayout3->addWidget(new QLabel(i18n("Slider:"), colorFrame3), 3, 0);
    cLayout3->addWidget(new QLabel(i18n("Arrow Button:"), colorFrame3), 4, 0);

    scrollbarBtn = new KColorButton(colorFrame3);
    cLayout3->addWidget(scrollbarBtn, 3, 1);
    scrollArbBtn = new KColorButton(colorFrame3);
    cLayout3->addWidget(scrollArbBtn, 4, 1);

    connect(useCustomColorBtn3, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor3Clicked(bool)));
    connect(scrollbarBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    connect(scrollArbBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));

    cLayout3->setColStretch(3, 1);
    layout->addWidget(colorGrp3);

    layout->addSpacing(5);

    // Push button prelight
    QVGroupBox *colorGrp4 = new QVGroupBox(i18n("Push button prelight"), page2);
    useCustomColorBtn4 = new QCheckBox(i18n("Use custom color"), colorGrp4);
    connect(useCustomColorBtn4, SIGNAL(toggled(bool)), this,
            SLOT(slotUseCustomColor4Clicked(bool)));
    QHBox *colorBox4 = new QHBox(colorGrp4);
    QLabel *btnprlLbl = new QLabel(i18n("Custom color:"), colorBox4);
    btnprlBtn = new KColorButton(colorBox4);
    connect(btnprlBtn, SIGNAL(changed(const QColor &)), this,
            SLOT(slotBtnColorChanged(const QColor &)));
    colorBox4->setStretchFactor(new QWidget(colorBox4), 1);

    layout->addWidget(colorGrp4);

    layout->addStretch(1);

    //--- tab 3 ---

    QWidget *page3 = new QWidget(tabWidget);
    layout = new QVBoxLayout(page3);
    layout->addSpacing(5);

    tabWidget->insertTab(page3, i18n("Others"));

    // Use Shadowed Text
    QVGroupBox *otherGrp1 = new QVGroupBox(i18n("Use Shadowed Text"), page3);
    useShdM = new QCheckBox(i18n("Menu"), otherGrp1);

    QHBox *dsbShdBox = new QHBox(otherGrp1);
    QLabel *dsbShdLblDmy = new QLabel("     ", dsbShdBox);
    disableShdEmpBtn = new QCheckBox(i18n("Disable emphasis of the selected menu item's shadow"), dsbShdBox);

    useShdMB = new QCheckBox(i18n("Menubar"), otherGrp1);
    useShdB = new QCheckBox(i18n("Push button"), otherGrp1);
    useShdT = new QCheckBox(i18n("Tab"), otherGrp1);

    connect(useShdM, SIGNAL(toggled(bool)), this,
            SLOT(slotUseShadowMClicked(bool)));
    connect(disableShdEmpBtn, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(useShdMB, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(useShdB, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(useShdT, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));

    dsbShdBox->setStretchFactor(new QWidget(dsbShdBox), 1);
    layout->addWidget(otherGrp1);
    layout->addSpacing(5);

    // Extra Options
    QVGroupBox *otherGrp2 = new QVGroupBox(i18n("Extra Options"), page3);
    useSlk = new QCheckBox(i18n("Use smooth kicker mode"), otherGrp2);
    useFlb = new QCheckBox(i18n("Use flat bevel buttons"), otherGrp2);
    usePBforDB = new QCheckBox(i18n("Use the pushbutton pixmap for the default button"), otherGrp2);
    disableBB = new QCheckBox(i18n("Disable border of menubars and toolbars"), otherGrp2);

    connect(useSlk, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(useFlb, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(usePBforDB, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));
    connect(disableBB, SIGNAL(toggled(bool)), this,
            SLOT(slotCheckBtnClicked(bool)));

    layout->addWidget(otherGrp2);

    layout->addStretch(1);

   //--- tab Scheme ---

    QWidget *pageScheme = new QWidget(tabWidget);
    layout = new QVBoxLayout(pageScheme);
    layout->addSpacing(5);
    tabWidget->insertTab(pageScheme, i18n("Scheme"));

    // Scheme
    QVGroupBox *scmGrp = new QVGroupBox(i18n("Config Scheme"), pageScheme);
    QLabel *schemeDmyLbl1 = new QLabel(i18n("\nThe config scheme is saved at"), scmGrp);
    QLabel *schemeDmyLbl2 = new QLabel(i18n("   \"$HOME/.qt/thinkeramik_<scheme name>.kcmrc\" file."), scmGrp);
    QLabel *schemeDmyLbl3 = new QLabel(i18n("   The characters which can be used for a scheme name are"), scmGrp);
    QLabel *schemeDmyLbl4 = new QLabel(i18n("   small letters of the alphabet, \"-\", and \"_\".\n"), scmGrp);

    QHBox *scmBox = new QHBox(scmGrp);
    QLabel *schemeLbl = new QLabel(i18n("Scheme Name:"), scmBox);
    schemeName = new QLineEdit(scmBox);
    loadSchemeBtn = new QPushButton(i18n("Load"),scmBox);
    saveSchemeBtn = new QPushButton(i18n("Save"),scmBox);
    delSchemeBtn = new QPushButton(i18n("Delete"),scmBox);
    scmBox->setStretchFactor(new QWidget(scmBox), 1);

    schemeListBox = new QListBox(scmGrp);
    schemeListBox->setMinimumSize(100,120);

    connect(loadSchemeBtn, SIGNAL(clicked()), this,
            SLOT(slotLoadScheme()));
    connect(saveSchemeBtn, SIGNAL(clicked()), this,
            SLOT(slotSaveScheme()));
    connect(delSchemeBtn, SIGNAL(clicked()), this,
            SLOT(slotDelScheme()));
    connect(schemeListBox, SIGNAL(clicked(QListBoxItem *)), this,
            SLOT(slotSchemeListClicked(QListBoxItem *)));
    connect(schemeListBox, SIGNAL(selectionChanged(QListBoxItem *)), this,
            SLOT(slotSchemeListClicked(QListBoxItem *)));

    layout->addWidget(scmGrp);
    layout->addStretch(1);

    load();
    searchScheme();

    menuFgBtn->setEnabled(useCustomColorBtn1->isOn());
    menuBgBtn->setEnabled(useCustomColorBtn1->isOn());
    menuStripeBtn->setEnabled(useCustomColorBtn1->isOn());

    customGradBtn->setEnabled(enableGradBtn->isOn());

    borderColBtn->setEnabled(useCustomColorBtn1b->isOn());

    menuSelFgBtn->setEnabled(useCustomColorBtn1c->isOn());
    menuSelBgBtn->setEnabled(useCustomColorBtn1c->isOn());
    menuSelShdBtn->setEnabled(useCustomColorBtn1c->isOn());

    menubgfile->setEnabled(useMenuBGI->isOn());
    menubgBrowse->setEnabled(useMenuBGI->isOn());
    scaledMenuBGI->setEnabled(useMenuBGI->isOn());

    strong3dmi->setEnabled(enableMI3d->isOn());
    strong3dms->setEnabled(enableMS3d->isOn());

    activeTabBtn->setEnabled(useCustomColorBtn2->isOn() && !disableUpperLinesBtn->isOn());
    useCustomColorBtn2->setEnabled(!disableUpperLinesBtn->isOn());

    scrollbarBtn->setEnabled(useCustomColorBtn3->isOn());
    scrollArbBtn->setEnabled(useCustomColorBtn3->isOn());

    btnprlBtn->setEnabled(useCustomColorBtn4->isOn());

    disableShdEmpBtn->setEnabled(useShdM->isOn());

    schemeName->setEnabled(true);
    loadSchemeBtn->setEnabled(true);
    saveSchemeBtn->setEnabled(true);
    delSchemeBtn->setEnabled(true);

    schemeListBox->setEnabled(true);
}

ThinKeramikConfig::~ThinKeramikConfig()
{
    ;
}



#include "thinkeramik.moc"
















